enum T<A>  { TI(int), TS(~str) }

fn make_int (i: int)  -> T<int>  { TI(i) }
fn make_str (s: ~str) -> T<~str> { TS(s) }

fn int_or_fail<A> (i: T<A>) -> int {
  match (i) {
    TI (i) => { i }
    TS (_) => { fail!("error") }
  }
}

fn str_or_fail<A> (i: T<A>) -> ~str {
  match (i) {
    TI (_) => { fail!("error") }
    TS (s) => { s }
  }
}

fn plus (lhs: T<int>, rhs: T<int>) -> T<int> {
  TI(int_or_fail (lhs) + int_or_fail (rhs))
}

fn concat (lhs: T<~str>, rhs: T<~str>) -> T<~str> {
   TS(str_or_fail (lhs) + str_or_fail (rhs))
}

fn display<A> (t: &T<A>) {
  match (*t) {
    TI(i) => { println(fmt!("int: %d", i)) }
    TS(ref s) => { println(fmt!("str: %s", *s)) }
  }
}


fn main() {
  let d1 = make_int(1);
  let d2 = make_int(2);
  let x = plus(d1, d2);
  display(&x);

  let d1 = make_str(~"Hello, ");
  let d2 = make_str(~"World");
  let y = concat (d1,d2);
  display(&y);

  // Compile error here
  let z = concat(x, y);
  display(&z);
}
